"use strict";
/**
 * 腾讯文档
 * https://docs.qq.com/open/wiki/OPENAPI.html
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.provider = exports.getAuthData = void 0;
const utils_1 = require("./utils");
async function getAuthData(dsId) {
    const dsToken = await utils_1.getToken(dsId);
    const authInfo = dsToken === null || dsToken === void 0 ? void 0 : dsToken.QQDocsToken;
    if (!authInfo || !authInfo.AccessToken) {
        throw new Error(`unable to get Tencent Docs token of datasource ${dsId}`);
    }
    return {
        headers: {
            'Access-Token': authInfo.AccessToken,
            'Client-Id': authInfo.ClientId,
            'Open-Id': authInfo.OpenId,
        },
    };
}
exports.getAuthData = getAuthData;
exports.provider = {
    getAuthData,
};
