import { IWedaRequestParams } from '@cloudbase/cloud-api';
export interface IWedaApiParams extends Partial<Omit<IWedaRequestParams, 'uid' | 'source' | 'requestId' | 'envType'>> {
    /** 方法名称 */
    action: string;
    /** 云API参数 */
    data?: Record<string, any>;
    /**
     * 是否自动将 data 的key 改为大写驼峰
     *  默认为 true, 即使用时 data 可以采用小驼峰的 key
     */
    capitalizeDataKey?: boolean;
    /**
     * 请求ID, 手动设置微搭后端请求的ID
     *  为 true 则复用 云开发云函数的请求ID
     *  为 string 则完全自定义请求ID
     */
    requestId?: boolean | string;
}
/**
 * 请求Weda后台接口
 * @param params 配置参数
 */
export declare function fetchWeda(params: IWedaApiParams): Promise<any>;
